org.apache.fop.area

## Class AreaTreeObject

- java.lang.Object
- - org.apache.fop.area.AreaTreeObject

All Implemented Interfaces:
  Cloneable

Direct Known Subclasses:
  Area, Page, PageSequence, PageViewport

    public abstract class AreaTreeObject
    extends Object
    implements Cloneable

Abstract base class for all area tree objects.

### Field Summary

Fields
`protected List<ExtensionAttachment>` `extensionAttachments` Extension attachments
`protected Map<org.apache.xmlgraphics.util.QName,String>` `foreignAttributes` Foreign attributes

### Constructor Summary

Constructors
Constructor and Description
`AreaTreeObject()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addExtensionAttachment(ExtensionAttachment attachment)` Adds a new ExtensionAttachment instance to this page.
`Object` `clone()`
`List<ExtensionAttachment>` `getExtensionAttachments()`
`Map<org.apache.xmlgraphics.util.QName,String>` `getForeignAttributes()`
`String` `getForeignAttributeValue(org.apache.xmlgraphics.util.QName name)` Returns the value of a foreign attribute on the area.
`boolean` `hasExtensionAttachments()` Indicates whether this area tree object has any extension attachments.
`void` `setExtensionAttachments(List<ExtensionAttachment> extensionAttachments)` Set extension attachments from a List
`void` `setForeignAttribute(org.apache.xmlgraphics.util.QName name, String value)` Sets a foreign attribute.
`void` `setForeignAttributes(Map<org.apache.xmlgraphics.util.QName,String> atts)` Add foreign attributes from a Map.

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### foreignAttributes

    protected Map<org.apache.xmlgraphics.util.QName,String> foreignAttributes

Foreign attributes

#### extensionAttachments

    protected List<ExtensionAttachment> extensionAttachments

Extension attachments

### Constructor Detail

#### AreaTreeObject

    public AreaTreeObject()

### Method Detail

#### clone

    public Object clone()
                 throws CloneNotSupportedException

Overrides:
  `clone` in class `Object`
Throws:
  `CloneNotSupportedException`

#### setForeignAttribute

    public void setForeignAttribute(org.apache.xmlgraphics.util.QName name,
                                    String value)

Sets a foreign attribute.

Parameters:
  `name` - the qualified name of the attribute
  `value` - the attribute value

#### setForeignAttributes

    public void setForeignAttributes(Map<org.apache.xmlgraphics.util.QName,String> atts)

Add foreign attributes from a Map.

Parameters:
  `atts` - a Map with attributes (keys: QName, values: String)

#### getForeignAttributeValue

    public String getForeignAttributeValue(org.apache.xmlgraphics.util.QName name)

Returns the value of a foreign attribute on the area.

Parameters:
  `name` - the qualified name of the attribute
Returns:
  the attribute value or null if it isn't set

#### getForeignAttributes

    public Map<org.apache.xmlgraphics.util.QName,String> getForeignAttributes()

Returns:
  the foreign attributes associated with this area

#### addExtensionAttachment

    public void addExtensionAttachment(ExtensionAttachment attachment)

Adds a new ExtensionAttachment instance to this page.

Parameters:
  `attachment` - the ExtensionAttachment

#### setExtensionAttachments

    public void setExtensionAttachments(List<ExtensionAttachment> extensionAttachments)

Set extension attachments from a List

Parameters:
  `extensionAttachments` - a List with extension attachments

#### getExtensionAttachments

    public List<ExtensionAttachment> getExtensionAttachments()

Returns:
  the extension attachments associated with this area

#### hasExtensionAttachments

    public boolean hasExtensionAttachments()

Indicates whether this area tree object has any extension attachments.

Returns:
  true if there are extension attachments